import { Dispatch } from 'redux';
export interface ActionClass<T extends Action> {
    prototype: T;
}
export declare function typeName(name: string): <T extends Action>(actionClass: ActionClass<T>) => void;
export declare function isActionType<T extends Action>(action: Action, actionClass: ActionClass<T>): action is T;
export declare const typedToPlain: (store: any) => (next: any) => (action: any) => void;
export declare abstract class Action {
    type: string;
    constructor();
}
export interface Reducer<TState> extends Function {
    (state: TState, action: Action): TState;
}
export interface ActionCreatorGeneric<TState> extends Function {
    (dispatch: Dispatch, getState: () => TState): any;
}
